//! A type containing some information about an error that occured
//! while deserializing a message from Zelilj.
const std = @import("std");

pos: usize,

/// A string of the json source starting at pos - 16 and ending at pos + 16
sample: []const u8,

/// The allocator that was used to create this object.
alloc: std.mem.Allocator,

const Self = @This();

pub fn init(alloc: std.mem.Allocator, pos: usize, data: []const u8) !Self {
    return .{
        .pos = pos,
        .sample = try alloc.dupe(u8, data[pos -| 16..pos + 16]),
        .alloc = alloc,
    };
}

pub fn deinit(self: Self) void {
    self.alloc.free(self.sample);
}
